// C Source File
// Created 3/28/02; 6:40:27 PM

#define USE_TI89
#define USE_TI92PLUS
#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN
#define PASSWORD_VARNAME "elockz"
#define PASSWORD_SYMNAME $(elockz)
#include <tigcclib.h>

#define program_version 1
int password[9];

static unsigned char lock_pointer[]={
	0b0011100,
	0b0110110,
	0b0110110,
	0b1111111,
	0b1110111,
 	0b1100011,
	0b1110111,
	0b1111111};

void drawbox(void) {
	DrawLine(24,33,136,33,A_NORMAL);
	DrawLine(24,65,136,65,A_NORMAL);
	DrawLine(23,32,137,32,A_NORMAL);
	DrawLine(23,66,137,66,A_NORMAL);
	
	DrawLine(24,33,24,65,A_NORMAL);
	DrawLine(136,33,136,65,A_NORMAL);
	DrawLine(23,32,23,66,A_NORMAL);
	DrawLine(137,32,137,66,A_NORMAL);
}

void drawbox_pass(void) {
	DrawLine(23,38,137,38,A_NORMAL);
	DrawLine(23,56,137,56,A_NORMAL);
	DrawLine(22,37,138,37,A_NORMAL);
	DrawLine(22,57,138,57,A_NORMAL);
	
	DrawLine(23,39,23,56,A_NORMAL);
	DrawLine(137,39,137,56,A_NORMAL);
	DrawLine(22,38,22,57,A_NORMAL);
	DrawLine(138,38,138,57,A_NORMAL);
}

void save_password(void){
	FILE* fp;
	int x,reduced_password,times;
	
	EM_moveSymFromExtMem(PASSWORD_SYMNAME,SymFind(PASSWORD_SYMNAME));
	if (!(fp=fopen(PASSWORD_VARNAME,"wb"))) {clrscr(); printf("Error writing file - password will not be saved"); GKeyIn(NULL,0); return;}
	fputc(program_version,fp);
	for(x=0;x<9;x++) {
		for (times=0,reduced_password=password[x];reduced_password>=255;times++) reduced_password-=256;
		fputc(times,fp);
		fputc(reduced_password,fp);
	}
	fputc(0,fp);
	fputs("eINI",fp);
	fputc(0,fp);
	fputc(OTH_TAG,fp);
	fclose(fp);
	EM_moveSymToExtMem(PASSWORD_SYMNAME,SymFind(PASSWORD_SYMNAME));
}

BOOL newpass(void) {
	int key=0,loop,passtemp1[9]={0,0,0,0,0,0,0,0,0},passtemp2[9]={0,0,0,0,0,0,0,0,0};
	begin:
	clrscr();
	printf("\n\n\n\n\n    Enter New Password:\n    ");
	drawbox_pass();
	for (loop=0,key=0;loop<9 && key!=13;loop++) {
		ST_stack(loop,9);	//does anyone know how to save this value at the begining of the program?
		passtemp1[loop]=key=GKeyIn(NULL,0);
		printf("*");
	}
	int x;
	for (x=0;x<5000;x++);
	
	clrscr();
	printf("\n\n\n\n\n    Re-Enter Password:\n    ");
	drawbox_pass();
	for (loop=0,key=0;loop<9 && key!=13;loop++) {
		ST_stack(loop,9);	//does anyone know how to save this value at the begining of the program?
		passtemp2[loop]=key=GKeyIn(NULL,0);
		printf("*");
	}
	
	for (loop=0;loop<9;loop++) {
		if (passtemp1[loop]!=passtemp2[loop]) {
			clrscr();
			printf("\n\n\n\n\n    Not the same.\n    Please try again");
			drawbox_pass();
			GKeyIn(NULL,0);
			for (loop=0;loop<9;loop++) {
				passtemp1[loop]=0;
				passtemp2[loop]=0;
			}
			goto begin;
		}
	}
	
	for (loop=0;loop<9;loop++) {
		password[loop]=0;
	}
	
	for (loop=0;loop<9;loop++){
		password[loop]=passtemp1[loop];
	}
	save_password();
	return 1;
}

int lock(int OFF) {
	int key=0,loop,messup=0;
	clrscr();
	if (OFF==1) off();
	printf("\n\n\n\n\n    Enter Password:\n    ");
	drawbox_pass();
	for (loop=0;loop<9 && key!=13;loop++) {
		ST_stack(loop,9);	//does anyone know how to save this value at the begining of the program?
		key=GKeyIn(NULL,0);
		if (key!=password[loop]) messup=1;
		if (key!=13) printf("*");
	}
	for (;loop<9;loop++) {
		if (0!=password[loop]) messup=1;
	}
	return messup;
}

int select(int num,int where_text_width,int where_text_height,int space) {
	int key=0,poss=1,poss_old;
	Sprite8((where_text_width-10),(where_text_height+((poss-1)*space)),8,lock_pointer,LCD_MEM,SPRT_OR);
	while (1) {
		ST_stack(poss,num);
		key=GKeyIn(NULL,0);	//does anyone know how to save this value at the begining of the program?
		poss_old=poss;
		if (key==KEY_DOWN) {
			if (poss!=num) poss++;
			else poss=1;
		}
		if (key==KEY_UP) {
			if (poss!=1) poss--;
			else poss=num;
		}
		if (key==KEY_RIGHT || key==KEY_F1 || key==KEY_ENTER) return poss;
		if (key==KEY_ESC) return 3;
		if (poss!=poss_old) {
			Sprite8((where_text_width-10),(where_text_height+((poss-1)*space)),8,lock_pointer,LCD_MEM,SPRT_OR);
			Sprite8((where_text_width-10),(where_text_height+((poss_old-1)*space)),8,lock_pointer,LCD_MEM,SPRT_XOR);
		}
	}
}

void menu(void) {
	int choice;
	a:
	clrscr();
	drawbox();
	FontSetSys(F_8x10);
	DrawStr(40,1,"eLock v1.0",A_NORMAL);
	DrawStr(16,12,"by Eric Anderson",A_NORMAL);
	DrawStr(16,80,"Thanks to: TIGCC",A_NORMAL);
	FontSetSys(F_6x8);
	DrawStr(35,35,"Lock Calc",A_NORMAL);
	DrawStr(35,45,"Change Password",A_NORMAL);
	DrawStr(35,55,"Exit",A_NORMAL);
	choice=select(3,35,35,10);
	if (choice==1) {
		int locked=1;
		while (locked!=0) locked=lock(1);
	}
	if (choice==2) {
		if (lock(0)) {
			clrscr();
			printf("\n\n\n\n\n    Wrong Password");
			drawbox_pass();
			GKeyIn(NULL,0);
			goto a;
		}
		newpass();
		goto a;
	}
}


void get_password(void){
	FILE* fp;
	int x,reduced_password,times;
	if ((!(fp=fopen(PASSWORD_VARNAME,"rb"))) || (program_version!=fgetc(fp))) {newpass(); fclose(fp); return;}
	for (x=0;x<9;x++) {
		times=fgetc(fp);
		reduced_password=fgetc(fp);
		password[x]=times*256+reduced_password;
	}
	fclose(fp);
}

void _main(void) {
	get_password();
	if (ArgCount()!=0) {	//if there was an argument - only lock the calc
		int locked=1;
		while (locked!=0) locked=lock(1);
	}
	else menu();					//if there wasn't an argument - normal program
}
